#ifndef INCLUDED_ESDOM_ESDOM_define_hpp
#define INCLUDED_ESDOM_ESDOM_define_hpp


#define FILE_CREATE_NEW			0x0001
#define FILE_CREATE_ALWAYS		0x0002
#define FILE_OPEN_EXISTING		0x0003
//#define FILE_CREATE_TEMPORARY	0x0004
#define FILE_OPEN_TYPE			0x000f

#define FILE_READ				0x0010
#define FILE_WRITE				0x0020
#define FILE_ACCESS_TYPE		0x0030

#define FILE_LOCK_SH	0x0001
#define FILE_LOCK_EX	0x0002
#define FILE_LOCK_NB	0x0004
#define FILE_LOCK_UN	0x0008

#define FILE_SEEK_SET	0
#define FILE_SEEK_CUR	1
#define FILE_SEEK_END	2


////////////////
// Platforms

#if defined(WIN32) || defined(_WIN32) || defined(__WIN32__)
	#include <ESDOM/Platforms/WIN32.hpp>
#elif defined(__linux__)
	#include <ESDOM/Platforms/linux.hpp>
#endif

////////////////
// Compilers

#if defined(_MSC_VER)
//for VC++
	#include <ESDOM/Compilers/VCPP.hpp>
#elif defined(__BORLANDC__)
//for Borland C++ Builder
	#include <ESDOM/Compilers/BorlandC.hpp>
#elif defined (__GNUG__)
	#include <ESDOM/Compilers/gcc.hpp>
#endif

#ifndef ESDOM_EXPORT
#define ESDOM_EXPORT
#endif/*ESDOM_EXPORT*/

#ifdef CAN_USE_L
#define ESDOM_TEXT(string)	L##string
#define _ESDOM_TEXT ESDOM_TEXT
#define CESDOM_TEXT ESDOM_TEXT
#else
#include <string>
namespace ESDOM {

	class ESDOM_EXPORT CESDOM_TEXT {
	public:
		CESDOM_TEXT(const char *string)
		{
			if(string)
			{
				m_data = new ESDOM_CHAR[::strlen(string)+1];
				ESDOM_CHAR *ptr = m_data;
				while(*string)
					*ptr++ = *string++;
				*ptr = 0;
			}
			else
				m_data = 0;
		}
		~CESDOM_TEXT()
		{
			if( m_data )
				delete[] m_data;
		}
		operator const ESDOM_CHAR*() const
		{
			return m_data;
		}
	private:
		ESDOM_CHAR *m_data;
	};
};
#define _ESDOM_TEXT(string) (const ESDOM_CHAR*)CESDOM_TEXT(string)
#endif /* CAN_USE_L */

#endif /* INCLUDED_ESDOM_ESDOM_define_hpp */
