#ifndef INCLUDED_ESDOM_Element_hpp
#define INCLUDED_ESDOM_Element_hpp

#include <ESDOM/NodeBase.hpp>
#include <ESDOM/ESDOMException.hpp>

namespace ESDOM
{

class ESDOM_EXPORT ElementInst;
class ESDOM_EXPORT Attr;
class ESDOM_EXPORT NodeList;

class ESDOM_EXPORT Element : public virtual NodeBase
{
public:
	Element();
	Element(const Element &original);
	Element(const ElementInst *instance);
	virtual ~Element();

	virtual Element &	operator = (const Element &node);

	virtual ESDOMString	getAttribute(const ESDOM_CHAR *name) const;
	virtual void		setAttribute(const ESDOM_CHAR *name, const ESDOM_CHAR *value) throw(ESDOMException);
	virtual void		removeAttribute(const ESDOM_CHAR *name) throw(ESDOMException);
	virtual Attr		getAttributeNode(const ESDOM_CHAR *name) const;
	virtual Attr		setAttributeNode(Attr newAttr) throw(ESDOMException);
	virtual Attr		removeAttributeNode(Attr oldAttr) throw(ESDOMException);
	virtual NodeList	getElementsByTagName(const ESDOM_CHAR *name) const;
	virtual void		normalize(void);

protected:

	friend	class	Parser;
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_Element_hpp */
