#ifndef INCLUDED_ESDOM_NamedNodeMap_hpp
#define INCLUDED_ESDOM_NamedNodeMap_hpp

#include <ESDOM/ESDOMException.hpp>
#include <ESDOM/Interface.hpp>

namespace ESDOM
{

class ESDOM_EXPORT NamedNodeMapInst;
class ESDOM_EXPORT Node;

class ESDOM_EXPORT NamedNodeMap : public Interface
{
public:
	NamedNodeMap();
	NamedNodeMap(const NamedNodeMap &original);
	NamedNodeMap(const NamedNodeMapInst *instance);
	~NamedNodeMap();

	NamedNodeMap & operator = (const NamedNodeMap &newNamedNodeMap);

	unsigned long	getLength(void) const;
	Node			getNamedItem(const ESDOM_CHAR *name) const;
	Node			setNamedItem(const Node arg) throw(ESDOMException);
	Node			removeNamedItem(const ESDOM_CHAR *name) throw(ESDOMException);
	Node			item(unsigned long index) const;

protected:
};

}; /* namespace ESDOM */

#endif /* INCLUDED_ESDOM_NamedNodeMap_hpp */
